## dolfin 1.0.0

=== CMakeLists.txt ===
# Top level CMakeLists.txt file for DOLFIN

# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

#------------------------------------------------------------------------------
# Set project name and version number

project(DOLFIN)
set(DOLFIN_VERSION_MAJOR "1")
set(DOLFIN_VERSION_MINOR "0")
set(DOLFIN_VERSION_MICRO "0")
set(DOLFIN_VERSION "${DOLFIN_VERSION_MAJOR}.${DOLFIN_VERSION_MINOR}.${DOLFIN_VERSION_MICRO}")

#------------------------------------------------------------------------------
# General configuration

# Set CMake options, see `cmake --help-policy CMP000x`
if (COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0004 OLD)
endif()

# Set location of our FindFoo.cmake modules
set(DOLFIN_CMAKE_DIR "${DOLFIN_SOURCE_DIR}/cmake" CACHE INTERNAL "")
set(CMAKE_MODULE_PATH "${DOLFIN_CMAKE_DIR}/modules")

# Make sure CMake uses the correct dolfin-config.cmake for tests and demos
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${CMAKE_CURRENT_BINARY_DIR}/dolfin)

#------------------------------------------------------------------------------
# Configurable options for how we want to build

option(BUILD_SHARED_LIBS "Build DOLFIN with shared libraries." ON)
option(CMAKE_SKIP_RPATH "Do not add runtime paths when using shared libraries." OFF)
option(CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath." ON)
option(CMAKE_USE_RELATIVE_PATHS "Use relative paths in makefiles and projects." OFF)
option(DOLFIN_DEBUG_UBLAS "Use extra uBLAS debugging." OFF)
option(DOLFIN_ENABLE_CODE_COVERAGE "Enable code coverage." OFF)
option(DOLFIN_WITH_LIBRARY_VERSION "Build with library version information." ON)
option(DOLFIN_ENABLE_UNIT_TESTS "Enable unit tests." ON)
option(DOLFIN_ENABLE_TESTING "Enable testing." OFF)
option(DOLFIN_ENABLE_BENCHMARKS "Enable benchmark programs." OFF)
option(DOLFIN_ENABLE_DOCS "Enable generation of documentation." ON)

#option(CMAKE_SKIP_RPATH "Do not add runtime paths when using shared libraries." ON)

#------------------------------------------------------------------------------
# Enable or disable optional packages

# FIXME: Discuss which should be enabled by default
# FIXME: AL: I suggest only the Python wrappers
# FIXME: GNW: That would lead to most demos failing (no LU solver)
# FIXME: GNW: I suggest enabling everything, but using QUIET to eliminate
#             excessive output
# FIXME: JR: What about adopting the way they do this in Trilinos? Then we
#            could have options like DOLFIN_ENABLE_ALL_PACKAGES for enabling
#            everything and DOLFIN_ENABLE_DEFAULT_PACKAGES for enabling only
#            some default packages.

# List optional packages
set(OPTIONAL_PACKAGES "")
list(APPEND OPTIONAL_PACKAGES "OpenMP")
list(APPEND OPTIONAL_PACKAGES "MPI")
list(APPEND OPTIONAL_PACKAGES "PETSc")
list(APPEND OPTIONAL_PACKAGES "SLEPc")
list(APPEND OPTIONAL_PACKAGES "Trilinos")
list(APPEND OPTIONAL_PACKAGES "MTL4")
list(APPEND OPTIONAL_PACKAGES "UMFPACK")
list(APPEND OPTIONAL_PACKAGES "CHOLMOD")
list(APPEND OPTIONAL_PACKAGES "SCOTCH")
list(APPEND OPTIONAL_PACKAGES "ParMETIS")
list(APPEND OPTIONAL_PACKAGES "CGAL")
list(APPEND OPTIONAL_PACKAGES "zlib")
list(APPEND OPTIONAL_PACKAGES "Python")
list(APPEND OPTIONAL_PACKAGES "Sphinx")

# Add options
foreach (OPTIONAL_PACKAGE ${OPTIONAL_PACKAGES})
  string(TOUPPER "DOLFIN_ENABLE_${OPTIONAL_PACKAGE}" OPTION_NAME)
  option(${OPTION_NAME} "Compile with support for ${OPTIONAL_PACKAGE}." ON)
endforeach()

#------------------------------------------------------------------------------
# Package-specific options

option(CGAL_DISABLE_ROUNDING_MATH_CHECK "Disable rounding math check in CGAL. This permits Valgrind to run." OFF)

#------------------------------------------------------------------------------
# Compiler flags

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug Developer MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Check for some compiler flags
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-pipe HAVE_PIPE)
if (HAVE_PIPE)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-pipe ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Add some strict compiler checks
CHECK_CXX_COMPILER_FLAG("-Wall -Werror -pedantic" HAVE_PEDANTIC)
if (HAVE_PEDANTIC)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-Wall -Werror -pedantic ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Disable strict checks that fail for inlcuded 3rd party libraries
CHECK_CXX_COMPILER_FLAG(-Wno-long-long HAVE_DISABLE_PEDANTIC_CHECKS)
if (HAVE_DISABLE_PEDANTIC_CHECKS)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-Wno-long-long ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

CHECK_CXX_COMPILER_FLAG(-std=c++98 HAVE_STD)
if (HAVE_STD)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-std=c++98 ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Debug flags
CHECK_CXX_COMPILER_FLAG(-g HAVE_DEBUG)
if (HAVE_DEBUG)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-g ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

CHECK_CXX_COMPILER_FLAG(-O2 HAVE_O2_OPTIMISATION)
if (HAVE_O2_OPTIMISATION)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-O2 ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Set 'Developer' build type flags
set(CMAKE_CXX_FLAGS_DEVELOPER "${DOLFIN_CXX_DEVELOPER_FLAGS}" CACHE STRING
  "Flags used by the compiler during development." FORCE)

# Do not debug uBLAS unless requested
if (NOT DOLFIN_DEBUG_UBLAS)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DBOOST_UBLAS_NDEBUG")
endif()

# FIXME: Do we want to add -DDEBUG to RelWithDebInfo?

# Add debug definitions
if (CMAKE_BUILD_TYPE STREQUAL "Developer" OR CMAKE_BUILD_TYPE STREQUAL "Debug")
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DDEBUG")
endif()

# Add flags for generating code coverage reports
if (DOLFIN_ENABLE_CODE_COVERAGE AND CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
endif()

#------------------------------------------------------------------------------
# Check for MPI and OpenMP

# FIXME: Should be set CMake to use the MPI compiler wrappers?

if (DOLFIN_ENABLE_MPI)
  find_package(MPI)
endif()

if (DOLFIN_ENABLE_OPENMP)
  find_package(OpenMP)
  include(CheckOpenMP)
  check_openmp_unsigned_int_loop_control_variable(OPENMP_UINT_TEST_RUNS)
  if (NOT OPENMP_UINT_TEST_RUNS)
    set(OPENMP_FOUND FALSE)
  endif()
endif()

#------------------------------------------------------------------------------
# Run tests to find required packages

# Check for Boost
set(BOOST_ROOT $ENV{BOOST_DIR})
set(Boost_USE_MULTITHREADED $ENV{BOOST_USE_MULTITHREADED})
set(Boost_ADDITIONAL_VERSIONS 1.43 1.43.0 1.44 1.44.0 1.45 1.45.0 1.46 1.46.0 1.46.1 1.47 1.47.0)

if (DOLFIN_ENABLE_MPI AND MPI_FOUND)
  find_package(Boost 1.36 COMPONENTS filesystem program_options system thread iostreams math_tr1 mpi serialization REQUIRED)
else()
  find_package(Boost 1.36 COMPONENTS filesystem program_options system thread iostreams math_tr1 REQUIRED)
endif()

# Check for required packages
find_package(UFC 2.0.2 QUIET HINTS ${UFC_DIR})
if (NOT UFC_FOUND)
  message(FATAL_ERROR "Could not find a configuration file for package UFC that is "
    "compatible with requested version 2.0.2.\n"
    "Set UFC_DIR to the directory containing a CMake configuration file for UFC.")
else()
  message(STATUS "UFC version: ${UFC_VERSION_STRING}")
endif()

find_package(Armadillo REQUIRED)
find_package(LibXml2 REQUIRED)

#------------------------------------------------------------------------------
# Run tests to find optional packages

# Note: Check for Python interpreter even when Python is disabled because it
#       is used to get the installation path for dolfin_utils
find_package(PythonInterp)
if (DOLFIN_ENABLE_PYTHON)
  find_package(PythonLibs)

  # If Python is found, check for NumPy and SWIG
  if (PYTHONINTERP_FOUND AND PYTHONLIBS_FOUND)
    find_package(NumPy REQUIRED)

    # This is to help pick up swig on Debian/Ubuntu. It can be removed
    # when Debian/Ubuntu rename swig2.0 -> swig
    find_program(SWIG_EXECUTABLE swig2.0)

    find_package(SWIG REQUIRED)
    if (${SWIG_VERSION} LESS 2.0)
      message(FATAL_ERROR " DOLFIN requires SWIG version 2.0 or greater. You have version ${SWIG_VERSION}. Set DOLFIN_ENABLE_PYTHON to False or install correct SWIG version.")
    endif()
    include(UseSWIG)
    set(PYTHON_FOUND TRUE)
  endif()

endif()

# Check for ParMETIS and SCOTCH
if (DOLFIN_ENABLE_MPI AND MPI_FOUND)
  if (DOLFIN_ENABLE_PARMETIS)
    find_package(ParMETIS)
  endif()

  if (DOLFIN_ENABLE_SCOTCH)
    find_package(ScotchPT)
  endif()
endif()

# Check for UMFPACK
if (DOLFIN_ENABLE_UMFPACK)
  find_package(AMD)
  find_package(BLAS)
  find_package(UMFPACK)
endif()

# Check for CHOLMOD
if (DOLFIN_ENABLE_CHOLMOD)
  find_package(CHOLMOD)
endif()

# Check for Trilinos and the requires Trilinos packages
if (DOLFIN_ENABLE_TRILINOS)
  message(STATUS "Checking for Trilinos")
  find_package(Trilinos 10.8.1 PATHS ${TRILINOS_DIR} ${Trilinos_DIR} $ENV{TRILINOS_DIR} QUIET)
  set(DOLFIN_TRILINOS_PACKAGES "Epetra;Zoltan;ML;Ifpack;Amesos")

  # Check for required packages
  set(DOLFIN_TRILINOS_PACKAGES_FOUND false)
  if (Trilinos_FOUND)
    message(STATUS "  Trilinos version ${Trilinos_VERSION} found. Checking for components")

    # Check for packages
    set(DOLFIN_TRILINOS_PACKAGES_FOUND true)
    foreach (package ${DOLFIN_TRILINOS_PACKAGES})
      find_package(${package} PATHS $ENV{TRILINOS_DIR} QUIET)
      if (NOT ${package}_FOUND)
        set(DOLFIN_TRILINOS_PACKAGES_FOUND false)
      endif()
    endforeach()

    if (DOLFIN_TRILINOS_PACKAGES_FOUND)
      message(STATUS "  All necessary Trilinos components found. Trilinos will be enabled")
      set(DOLFIN_TRILINOS_DEFINITIONS)

      # Loop over each package
      foreach (package ${DOLFIN_TRILINOS_PACKAGES})
        # Loop over libs and get full path
        foreach (lib ${${package}_LIBRARIES})
          find_library(TRILINOS_LIB_${lib} ${lib} HINTS ${${package}_LIBRARY_DIRS})
          if (TRILINOS_LIB_${lib})
            list(APPEND DOLFIN_TRILINOS_LIBRARIES ${TRILINOS_LIB_${lib}})
          endif()
        endforeach()
      endforeach()

      # Remove duplicates
      list(REVERSE DOLFIN_TRILINOS_LIBRARIES)
      list(REMOVE_DUPLICATES DOLFIN_TRILINOS_LIBRARIES)
      list(REVERSE DOLFIN_TRILINOS_LIBRARIES)

    else()
      message(STATUS "Trilinos found, but some required components are missing.")
      foreach (package ${DOLFIN_TRILINOS_PACKAGES})
        message(STATUS "  ${package}: ${${package}_FOUND}")
      endforeach()
    endif()

  else()
    message(STATUS "Trilinos could not be found")
  endif()
endif()

# Check for MTL4
if (DOLFIN_ENABLE_MTL4)
  find_package(MTL4)
endif()

# Check for PETSc and SLEPc
if (DOLFIN_ENABLE_PETSC)
  find_package(PETSc)
  if (PETSC_FOUND AND DOLFIN_ENABLE_SLEPC)
    find_package(SLEPc)
  endif()
endif()

# Check for CGAL
if (DOLFIN_ENABLE_CGAL)
  find_package(CGAL)
endif()

# Check for zlib
if (DOLFIN_ENABLE_ZLIB)
  find_package(ZLIB)
endif()

# Check for cppunit
if (DOLFIN_ENABLE_UNIT_TESTS)
  find_package(CppUnit)
endif()

# Check for Sphinx
if (DOLFIN_ENABLE_DOCS AND PYTHON_FOUND)
  find_package(Sphinx 1.0.7)
endif()

#------------------------------------------------------------------------------
# Print summary of found and not found optional packages

# FIXME: Use FeatureSummary.cmake to do this

# Gather information about which optional packages were found and not found
set(OPTIONAL_PACKAGES_FOUND "")
set(OPTIONAL_PACKAGES_NOT_FOUND "")
set(OPTIONAL_PACKAGES_NOT_ENABLED "")
foreach (OPTIONAL_PACKAGE ${OPTIONAL_PACKAGES})
  string(TOUPPER "${OPTIONAL_PACKAGE}" PKG)
  if (${PKG}_FOUND OR ${OPTIONAL_PACKAGE}_FOUND)
    list(APPEND OPTIONAL_PACKAGES_FOUND ${PKG})
  elseif (DOLFIN_ENABLE_${PKG})
    list(APPEND OPTIONAL_PACKAGES_NOT_FOUND ${PKG})
  else()
    list(APPEND OPTIONAL_PACKAGES_NOT_ENABLED ${PKG})
  endif()
endforeach()

=== bench/CMakeLists.txt ===
# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

# FIXME: Temporary fix for whitespace error
cmake_policy(SET CMP0004 OLD)

# Find DOLFIN config file (not used here, but check that benchmarks will be
# able to find it
find_package(dolfin REQUIRED)

# If config file is found, add all demo sub-directories, else print helper
# message
if (dolfin_FOUND)

  # Build list of all cpp directories
  file( GLOB_RECURSE list "main.cpp")
  list( SORT list )
  string(REGEX REPLACE "/main.cpp" "" list "${list}")

  # Add each C++ code directory
  foreach (cpp_dir ${list})
    #message(STATUS "Add C++ benchmark: ${cpp_dir}")
    add_subdirectory(${cpp_dir})
  endforeach()

else()

  message(STATUS "Could not locate dolfin-config.cmake file. Did you do 'make install' for the DOLFIN library and set the appropriate paths (source <build_dir>/dolfin.conf)?")

endif()

=== demo/CMakeLists.txt ===
project(dolfin-demos)

# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

# FIXME: Temporary fix for whitespace error
cmake_policy(SET CMP0004 OLD)

# Find DOLFIN config file (not used here, but check that the demo will be able
# to find it
find_package(dolfin PATHS ${CMAKE_BINARY_DIR} REQUIRED)

# If config file is found, add all demo sub-directories, else print helper
# message
if (dolfin_FOUND)

  # Build list of all cpp demo directories
  file(GLOB_RECURSE list "main.cpp")
  list(SORT list)
  string(REGEX REPLACE "/main.cpp" "" list "${list}")

  # Add each C++ demo directory
  foreach (demo_dir ${list})
    #message(STATUS "Adding C++ demo: ${demo_dir}")
    add_subdirectory(${demo_dir})
  endforeach()

else()

  message("Could not locate dolfin-config.cmake file. Did you do 'make install' for the DOLFIN library and set the appropriate paths (source <build_dir>/dolfin.conf)?")

endif()

=== dolfin/CMakeLists.txt ===
set(DOLFIN_H dolfin.h)
install(FILES ${DOLFIN_H} DESTINATION ${DOLFIN_INCLUDE_DIR} COMPONENT Development)

#set(CMAKE_SKIP_BUILD_RPATH  FALSE)
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

#------------------------------------------------------------------------------
# DOLFIN source directories

set(DOLFIN_DIRS
  adaptivity
  ale
  common
  fem
  function
  graph
  intersection
  io
  la
  log
  math
  mesh
  nls
  parameter
  plot
  quadrature
  refinement
  )

#------------------------------------------------------------------------------
# Install header files

foreach(DIR ${DOLFIN_DIRS})
  file(GLOB _HEADERS ${DIR}/*.h)
  list(APPEND HEADERS ${_HEADERS})
  install(FILES ${_HEADERS} DESTINATION ${DOLFIN_INCLUDE_DIR}/dolfin/${DIR} COMPONENT Development)

  file(GLOB _SOURCES ${DIR}/*.cpp)
  list(APPEND SOURCES ${_SOURCES})
endforeach()

#------------------------------------------------------------------------------
# Add include directories and libs of required packages

# libXml2
list(APPEND DOLFIN_INCLUDE_DIRECTORIES  ${LIBXML2_INCLUDE_DIR})
list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${LIBXML2_LIBRARIES})
list(APPEND DOLFIN_CXX_DEFINITIONS ${LIBXML2_DEFINITIONS})

# UFC
list(APPEND DOLFIN_INCLUDE_DIRECTORIES  ${UFC_INCLUDE_DIRS})

# Armadillo
list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${ARMADILLO_INCLUDE_DIRS})
list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${ARMADILLO_LIBRARIES})
list(APPEND DOLFIN_LINK_FLAGS ${ARMADILLO_LINK_FLAGS})

# Boost
list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${Boost_INCLUDE_DIR})
list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${Boost_LIBRARIES})
list(APPEND APPEND DOLFIN_TARGET_LINK_LIBRARIES_DIRS ${Boost_LIBRARY_DIRS})

#------------------------------------------------------------------------------

# Trilinos
if (DOLFIN_ENABLE_TRILINOS AND DOLFIN_TRILINOS_PACKAGES_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_TRILINOS")
  list(APPEND DOLFIN_CXX_DEFINITIONS ${DOLFIN_TRILINOS_DEFINITIONS})
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${Trilinos_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${DOLFIN_TRILINOS_LIBRARIES})
endif()

# SLEPC
if (DOLFIN_ENABLE_PETSC AND DOLFIN_ENABLE_SLEPC AND SLEPC_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_SLEPC")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${SLEPC_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${SLEPC_LIBRARIES})
endif()

# PETSc
if (DOLFIN_ENABLE_PETSC AND PETSC_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_PETSC")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${PETSC_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${PETSC_LIBRARIES})
endif()

# MTL4
if (DOLFIN_ENABLE_MTL4 AND MTL4_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_MTL4")
  list(APPEND DOLFIN_CXX_DEFINITIONS ${MTL4_DEFINITIONS})
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${MTL4_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${MTL4_LIBRARIES})
endif()

# UMFPACK
if (DOLFIN_ENABLE_UMFPACK AND UMFPACK_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_UMFPACK")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${UMFPACK_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${UMFPACK_LIBRARIES})
endif()

# CHOLMOD
if (DOLFIN_ENABLE_CHOLMOD AND CHOLMOD_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_CHOLMOD")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${CHOLMOD_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${CHOLMOD_LIBRARIES})
endif()

# SCOTCH
if (DOLFIN_ENABLE_SCOTCH AND SCOTCH_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_SCOTCH")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${SCOTCH_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${SCOTCH_LIBRARIES})
endif()

# ParMETIS
if (DOLFIN_ENABLE_PARMETIS AND PARMETIS_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_PARMETIS")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${PARMETIS_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${PARMETIS_LIBRARIES})
endif()

# CGAL
if (DOLFIN_ENABLE_CGAL AND CGAL_FOUND)

  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_CGAL")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${CGAL_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${CGAL_LIBRARIES})

  # Add -frounding-math if we have a GNU compiler
  if (CGAL_DISABLE_ROUNDING_MATH_CHECK)
    list(APPEND DOLFIN_CXX_DEFINITIONS "-DCGAL_DISABLE_ROUNDING_MATH_CHECK")
  else()
    if (CMAKE_COMPILER_IS_GNUCXX)
      set(DOLFIN_CXX_FLAGS "${DOLFIN_CXX_FLAGS} -frounding-math")
    endif()
  endif()

endif()

# ZLIB
if (DOLFIN_ENABLE_ZLIB AND ZLIB_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_ZLIB")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${ZLIB_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${ZLIB_LIBRARIES})
endif()

# CppUnit
if (DOLFIN_ENABLE_UNIT_TESTS AND CPPUNIT_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_CPPUNIT")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${CPPUNIT_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${CPPUNIT_LIBRARIES})
endif()

# MPI
if (DOLFIN_ENABLE_MPI AND MPI_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_MPI")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${MPI_INCLUDE_PATH})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${MPI_LIBRARIES})
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${MPI_INCLUDE_PATH})
  set(DOLFIN_CXX_FLAGS "${DOLFIN_CXX_FLAGS} ${MPI_COMPILE_FLAGS}")

  # FIXME: Is this linker flag required?
  #list(APPEND DOLFIN_LINK_FLAGS ${MPI_LINK_FLAGS})

  # Necessary flag for MPICH2
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DMPICH_IGNORE_CXX_SEEK")

endif()

# OpenMP
if (DOLFIN_ENABLE_OPENMP AND OPENMP_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_OPENMP")
  set(DOLFIN_CXX_FLAGS "${DOLFIN_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")

  if (MINGW)
    list(APPEND DOLFIN_LINK_FLAGS "${OpenMP_CXX_FLAGS}")
  endif()

endif()

#------------------------------------------------------------------------------
# Set compiler flags, include directories and library dependencies

# Add compiler include directories
include_directories(${DOLFIN_SOURCE_DIR} ${DOLFIN_INCLUDE_DIRECTORIES})

# Add CXX defintions
add_definitions(${DOLFIN_CXX_DEFINITIONS})
add_definitions(-DDOLFIN_VERSION="${DOLFIN_VERSION}")

# Add flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DOLFIN_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${DOLFIN_LINK_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${DOLFIN_LINK_FLAGS}")

# Define libraries
add_library(dolfin ${DOLFIN_H} ${HEADERS} ${SOURCES})
set_target_properties(dolfin PROPERTIES ${DOLFIN_LIBRARY_PROPERTIES})

# Strip leading and trailing whitespaces
string(STRIP DOLFIN_TARGET_LINK_LIBRARIES "${DOLFIN_TARGET_LINK_LIBRARIES}")

# Add DOLFIN target libraries
target_link_libraries(dolfin ${DOLFIN_TARGET_LINK_LIBRARIES})

#------------------------------------------------------------------------------
# SWIG

if (PYTHONINTERP_FOUND AND PYTHONLIBS_FOUND AND SWIG_FOUND)

  # Make sure we can import the UFC module and that it is compiled with present
  # version of SWIG
  execute_process(
    COMMAND ${PYTHON_EXECUTABLE} -c "from ufc import *; import sys; sys.stdout.write('.'.join([str(int(s)) for s in ufc.__swigversion__.split('.')]))"
    OUTPUT_VARIABLE UFC_SWIGVERSION
    RESULT_VARIABLE UFC_MODULE_NOT_FOUND
    )

  # Check that UFC can be imported
  if (UFC_MODULE_NOT_FOUND)
    message(WARNING "Unable to import UFC. Install latest UFC or check that PYTHONPATH is set appropriately. Python will be disabled.")
  endif()

  # Check that UFC was built with the version of SWIG that is being used
  if (NOT UFC_MODULE_NOT_FOUND AND (NOT "${SWIG_VERSION}" STREQUAL "${UFC_SWIGVERSION}"))
    message(WARNING "UFC compiled with different version of SWIG. Please install SWIG version ${UFC_SWIGVERSION} or recompile UFC with present SWIG.")
  endif()

  # If suitble UFC SWIG extension is found, add SWIG subdirectory
  if (NOT UFC_MODULE_NOT_FOUND AND ("${SWIG_VERSION}" STREQUAL "${UFC_SWIGVERSION}"))
    add_subdirectory(swig)
  endif()

endif()

#------------------------------------------------------------------------------
# Install

install(TARGETS dolfin
  RUNTIME DESTINATION ${DOLFIN_LIB_DIR} COMPONENT RuntimeExecutables
  LIBRARY DESTINATION ${DOLFIN_LIB_DIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${DOLFIN_LIB_DIR} COMPONENT Development
  )

#------------------------------------------------------------------------------
# Generate pkg-config file and install it

# Define packages that should be required by pkg-config file
set(PKG_REQUIRES "ufc-1 libxml-2.0")

# Convert include dirs to -I<incdir> form
foreach(_inc_dir ${DOLFIN_INCLUDE_DIRECTORIES})
  set(PKG_INCLUDES "-I${_inc_dir} ${PKG_INCLUDES}")
endforeach()

# Convert compiler flags and definitions into space separated strings
string(REPLACE ";" " " PKG_CXXFLAGS "${CMAKE_CXX_FLAGS}")
string(REPLACE ";" " " PKG_LINKFLAGS "${CMAKE_EXE_LINKER_FLAGS}")
string(REPLACE ";" " " PKG_DEFINITIONS "${DOLFIN_CXX_DEFINITIONS}")

# Convert libraries to -L<libdir> -l<lib> form
foreach(_lib ${DOLFIN_TARGET_LINK_LIBRARIES})
  string(REGEX REPLACE "(.?:?/[^ ]*)/lib([^ ]*)\\.(a|so|dylib|dll)" "-L\\1 -l\\2"
    _linkflags
    "${_lib}"
    )

  # Only add libraries that matches the form -L<libdir> -l<lib>
  if ("${_linkflags}" MATCHES "-L.+ -l.+")
    set(PKG_LINKFLAGS "${_linkflags} ${PKG_LINKFLAGS}")
  endif()
endforeach()

# Remove duplicated link flags
separate_arguments(PKG_LINKFLAGS)
list(REMOVE_DUPLICATES PKG_LINKFLAGS)
string(REPLACE ";" " " PKG_LINKFLAGS "${PKG_LINKFLAGS}")

# Add additional link flags
foreach(_linkflag ${DOLFIN_LINK_FLAGS})
  set(PKG_LINKFLAGS "${PKG_LINKFLAGS} ${_linkflag}")
endforeach()

# Configure and install pkg-config file
configure_file(${DOLFIN_CMAKE_DIR}/templates/dolfin.pc.in ${CMAKE_BINARY_DIR}/dolfin.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/dolfin.pc
  DESTINATION ${DOLFIN_PKGCONFIG_DIR}
  COMPONENT Development
  )

#------------------------------------------------------------------------------
# Generate CMake config files (dolfin-config{,-version}.cmake)

# Set library location
get_target_property(DOLFIN_LIBRARY_LOCATION dolfin LOCATION)
get_filename_component(DOLFIN_LIBRARY_FILENAME ${DOLFIN_LIBRARY_LOCATION} NAME)
set(DOLFIN_LIBRARY "${CMAKE_INSTALL_PREFIX}/${DOLFIN_LIB_DIR}/${DOLFIN_LIBRARY_FILENAME}")

configure_file(${DOLFIN_CMAKE_DIR}/templates/dolfin-config.cmake.in
  ${CMAKE_BINARY_DIR}/dolfin/dolfin-config.cmake @ONLY)
configure_file(${DOLFIN_CMAKE_DIR}/templates/dolfin-config-version.cmake.in
  ${CMAKE_BINARY_DIR}/dolfin/dolfin-config-version.cmake @ONLY)
install(
  FILES
    ${CMAKE_BINARY_DIR}/dolfin/dolfin-config.cmake
    ${CMAKE_BINARY_DIR}/dolfin/dolfin-config-version.cmake
  DESTINATION ${DOLFIN_SHARE_DIR}/cmake
  COMPONENT Development
  )

#------------------------------------------------------------------------------

=== test/CMakeLists.txt ===
project(dolfin-tests)

# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

# FIXME: Temporary fix for whitespace error
cmake_policy(SET CMP0004 OLD)

# Set special link option, see `cmake --help-policy CMP0003`
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif()

# Find DOLFIN config file (not used here, but checks that tests will be able
# to find it
find_package(dolfin REQUIRED)

# If config file is found, add all demo sub-directories, else print helper
# message
if (dolfin_FOUND)

  # Build list of all cpp directories
  file(GLOB_RECURSE list "test.cpp")
  list(SORT list)
  string(REGEX REPLACE "/test.cpp" "" list "${list}")

  # Add each C++ demo directory
  foreach (cpp_dir ${list})
    #message(STATUS "Add C++ test: ${cpp_dir}")
    add_subdirectory(${cpp_dir})
  endforeach()

else()

  message(STATUS "Could not locate dolfin-config.cmake file. Did you do 'make install' for the DOLFIN library and set the appropriate paths (source <build_dir>/dolfin.conf)?")

endif()

=== dolfin/swig/CMakeLists.txt ===
project(cpp)

#SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

get_directory_property(cmake_defs COMPILE_DEFINITIONS)
set(SWIG_MODULE_NAME cpp)
set(CMAKE_SWIG_FLAGS
  -module ${SWIG_MODULE_NAME}
  -shadow
  -modern
  -modernargs
  -fastdispatch
  -fvirtual
  -nosafecstrings
  -noproxydel
  -fastproxy
  -fastinit
  -fastunpack
  -fastquery
  -nobuildnone
  -Iinclude/swig
  ${DOLFIN_CXX_DEFINITIONS}
  )
set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR})

# Get all SWIG interface files
file(GLOB DOLFIN_SWIG_INTERFACE_FILES "*.i")

# and the DOLFIN header files
execute_process(
  COMMAND ${PYTHON_EXECUTABLE} -c "import sys, re; sys.stdout.write(';'.join([r'${DOLFIN_SOURCE_DIR}/'+re.findall('dolfin.*\\.h', l)[0] for l in open(r'${DOLFIN_SOURCE_DIR}/'+'dolfin/swig/kernel_modules.i').readlines() if '%include' in l and not 'swig' in l]))"
  OUTPUT_VARIABLE SWIG_KERNEL_MODULES
)

# Set SWIG source file
set(SWIG_SOURCES dolfin.i)
set_source_files_properties(${SWIG_SOURCES} PROPERTIES CPLUSPLUS ON)

# Remove '-Werror', '-Wall' and 'pedantic' flags (if present) when compiling SWIG-generated files
string(REGEX REPLACE "-Wall" " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
string(REGEX REPLACE "-Wall" " " CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER}")
string(REGEX REPLACE "-Werror=format-security" " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
string(REGEX REPLACE "-Werror=format-security" " " CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER}")
string(REGEX REPLACE "-Werror" " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
string(REGEX REPLACE "-Werror" " " CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER}")
string(REGEX REPLACE "-pedantic" " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
string(REGEX REPLACE "-pedantic" " " CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER}")

# The prevents swig being run unnecessarily
set_source_files_properties(dolfin.i PROPERTIES SWIG_MODULE_NAME cpp)

# Tell CMake which SWIG interface files should be checked for changes when recompile
set(SWIG_MODULE_cpp_EXTRA_DEPS ${DOLFIN_SWIG_INTERFACE_FILES})
list(APPEND SWIG_MODULE_cpp_EXTRA_DEPS ${SWIG_KERNEL_MODULES})

include_directories(${PYTHON_INCLUDE_DIRS} ${NUMPY_INCLUDE_DIR})
swig_add_module(${SWIG_MODULE_NAME} python ${SWIG_SOURCES})
swig_link_libraries(cpp dolfin ${PYTHON_LIBRARIES})

get_target_property(SWIG_MODULE_LOCATION ${SWIG_MODULE_cpp_REAL_NAME} LOCATION)

# Install Python .py files
install(FILES
  ${SWIG_MODULE_LOCATION} ${CMAKE_CURRENT_BINARY_DIR}/${SWIG_MODULE_NAME}.py
  DESTINATION ${DOLFIN_INSTALL_PYTHON_MODULE_DIR}/dolfin
  COMPONENT RuntimeLibraries
  )

install(FILES ${DOLFIN_SWIG_INTERFACE_FILES}
  DESTINATION ${DOLFIN_INCLUDE_DIR}/dolfin/swig
  COMPONENT Development
  )

install(DIRECTORY "import"
  DESTINATION ${DOLFIN_INCLUDE_DIR}/dolfin/swig
  USE_SOURCE_PERMISSIONS
  COMPONENT Development
  )

=== bench/common/progress/cpp/CMakeLists.txt ===
# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

project(bench_progress)

# Set verbose output while testing CMake
#set(CMAKE_VERBOSE_MAKEFILE 1)

# Set CMake behavior
cmake_policy(SET CMP0004 OLD)

# Get DOLFIN configuration data (dolfin-config.cmake must be in DOLFIN_CMAKE_CONFIG_PATH)
find_package(dolfin)

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Compiler definitions
add_definitions(${DOLFIN_CXX_DEFINITIONS})

# Add special DOLFIN compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DOLFIN_CXX_FLAGS}")

# Include directories
include_directories(${DOLFIN_INCLUDE_DIRS} ${DOLFIN_3RD_PARTY_INCLUDE_DIRS})

# Executable
add_executable(bench_progress main.cpp)

# Target libraries
target_link_libraries(bench_progress ${DOLFIN_LIBRARIES} ${DOLFIN_3RD_PARTY_LIBRARIES})

=== bench/common/timing/cpp/CMakeLists.txt ===
# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

project(bench_timing)

# Set verbose output while testing CMake
#set(CMAKE_VERBOSE_MAKEFILE 1)

# Set CMake behavior
cmake_policy(SET CMP0004 OLD)

# Get DOLFIN configuration data (dolfin-config.cmake must be in DOLFIN_CMAKE_CONFIG_PATH)
find_package(dolfin)

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Compiler definitions
add_definitions(${DOLFIN_CXX_DEFINITIONS})

# Add special DOLFIN compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DOLFIN_CXX_FLAGS}")

# Include directories
include_directories(${DOLFIN_INCLUDE_DIRS} ${DOLFIN_3RD_PARTY_INCLUDE_DIRS})

# Executable
add_executable(bench_timing main.cpp)

# Target libraries
target_link_libraries(bench_timing ${DOLFIN_LIBRARIES} ${DOLFIN_3RD_PARTY_LIBRARIES})

=== bench/fem/assembly/cpp/CMakeLists.txt ===
# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

project(bench_assembly)

# Set verbose output while testing CMake
#set(CMAKE_VERBOSE_MAKEFILE 1)

# Set CMake behavior
cmake_policy(SET CMP0004 OLD)

# Get DOLFIN configuration data (dolfin-config.cmake must be in DOLFIN_CMAKE_CONFIG_PATH)
find_package(dolfin)

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Compiler definitions
add_definitions(${DOLFIN_CXX_DEFINITIONS})

# Add special DOLFIN compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DOLFIN_CXX_FLAGS}")

# Include directories
include_directories(${DOLFIN_INCLUDE_DIRS} ${DOLFIN_3RD_PARTY_INCLUDE_DIRS})

# Executable
add_executable(bench_assembly main.cpp)

# Target libraries
target_link_libraries(bench_assembly ${DOLFIN_LIBRARIES} ${DOLFIN_3RD_PARTY_LIBRARIES})

=== bench/fem/convergence/cpp/CMakeLists.txt ===
# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

project(bench_convergence)

# Set verbose output while testing CMake
#set(CMAKE_VERBOSE_MAKEFILE 1)

# Set CMake behavior
cmake_policy(SET CMP0004 OLD)

# Get DOLFIN configuration data (dolfin-config.cmake must be in DOLFIN_CMAKE_CONFIG_PATH)
find_package(dolfin)

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Compiler definitions
add_definitions(${DOLFIN_CXX_DEFINITIONS})

# Add special DOLFIN compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DOLFIN_CXX_FLAGS}")

# Include directories
include_directories(${DOLFIN_INCLUDE_DIRS} ${DOLFIN_3RD_PARTY_INCLUDE_DIRS})

# Executable
add_executable(bench_convergence main.cpp)

# Target libraries
target_link_libraries(bench_convergence ${DOLFIN_LIBRARIES} ${DOLFIN_3RD_PARTY_LIBRARIES})

=== bench/fem/multicore/cpp/CMakeLists.txt ===
# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

project(bench_multicore)

# Set verbose output while testing CMake
#set(CMAKE_VERBOSE_MAKEFILE 1)

# Set CMake behavior
cmake_policy(SET CMP0004 OLD)

# Get DOLFIN configuration data (dolfin-config.cmake must be in DOLFIN_CMAKE_CONFIG_PATH)
find_package(dolfin)

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Compiler definitions
add_definitions(${DOLFIN_CXX_DEFINITIONS})

# Add special DOLFIN compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DOLFIN_CXX_FLAGS}")

# Include directories
include_directories(${DOLFIN_INCLUDE_DIRS} ${DOLFIN_3RD_PARTY_INCLUDE_DIRS})

# Executable
add_executable(bench_multicore main.cpp)

# Target libraries
target_link_libraries(bench_multicore ${DOLFIN_LIBRARIES} ${DOLFIN_3RD_PARTY_LIBRARIES})

=== bench/fem/speedup/cpp/CMakeLists.txt ===
# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

project(bench_speedup)

# Set verbose output while testing CMake
#set(CMAKE_VERBOSE_MAKEFILE 1)

# Set CMake behavior
cmake_policy(SET CMP0004 OLD)

# Get DOLFIN configuration data (dolfin-config.cmake must be in DOLFIN_CMAKE_CONFIG_PATH)
find_package(dolfin)

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Compiler definitions
add_definitions(${DOLFIN_CXX_DEFINITIONS})

# Add special DOLFIN compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DOLFIN_CXX_FLAGS}")

# Include directories
include_directories(${DOLFIN_INCLUDE_DIRS} ${DOLFIN_3RD_PARTY_INCLUDE_DIRS})

# Executables
add_executable(assemble-poisson assemble-poisson.cpp)
add_executable(solve-poisson solve-poisson.cpp)

# Target libraries
target_link_libraries(assemble-poisson ${DOLFIN_LIBRARIES} ${DOLFIN_3RD_PARTY_LIBRARIES})
target_link_libraries(solve-poisson ${DOLFIN_LIBRARIES} ${DOLFIN_3RD_PARTY_LIBRARIES})

=== debian/changelog ===
dolfin (1.0.0-7) unstable; urgency=low

  * debian/control:
    - Remove Conflicts and Replaces from binary package libdolfin1.0-dbg.
    - Update long description for all packages.
    - Add python-netcdf to Depends for binary package python-dolfin
      (closes: #674014).
    - Require SWIG upstream version 2.0.7 for binary package
      python-dolfin (closes: #675207).
    - Require UFC >= 2.0.5-3.

 -- Johannes Ring <johannr@simula.no>  Fri, 29 Jun 2012 09:45:28 +0200

dolfin (1.0.0-6) unstable; urgency=low

  * debian/rules: Set default Python version to fix FTBFS when Python3
    is available (closes: #672952).
  * debian/control: Remove Provides: libdolfin0-dev from
    libdolfin1.0-dev (and same to -dbg package).

 -- Johannes Ring <johannr@simula.no>  Mon, 21 May 2012 10:09:59 +0200

dolfin (1.0.0-5) unstable; urgency=low

  * Add patches to fix problems with SWIG 2.0.5 and GCC 4.7.
  * debian/control: Require UFC >= 2.0.5-2.

 -- Johannes Ring <johannr@simula.no>  Mon, 14 May 2012 11:25:47 +0200

dolfin (1.0.0-4) unstable; urgency=low

  * debian/watch: Replace http with https in URL.
  * debian/control:
    - Add libcgal-dev to Build-Depends and Depends for binary package
      libdolfin1.0-dev.
    - Bump Standards-Version to 3.9.3 (no changes needed).
  * debian/rules:
    - Enable CGAL support.
    - Call dh_numpy in binary-install/python-dolfin target to fix
      lintian error missing-dependency-on-numpy-abi.

 -- Johannes Ring <johannr@simula.no>  Tue, 20 Mar 2012 14:47:27 +0100

dolfin (1.0.0-3) unstable; urgency=low

  * Disable building with PETSc, SLEPc and SCOTCH on some arches.

 -- Johannes Ring <johannr@simula.no>  Tue, 14 Feb 2012 11:46:11 +0100

dolfin (1.0.0-2) unstable; urgency=low

  * debian/control:
    - Replace libpetsc3.1-dev and libslepc3.1-dev with libpetsc3.2-dev
      and libslepc3.2-dev, respectively.
    - Require libptscotch-dev, libpetsc3.2-dev and libslepc3.2-dev on
      all arches.
  * debian/rules: Help CMake find version 3.2 of PETSc and SLEPc by
    defining PETSC_DIR and SLEPC_DIR variables, respectively.

 -- Johannes Ring <johannr@simula.no>  Mon, 30 Jan 2012 11:45:31 +0100

dolfin (1.0.0-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - Bump version numbers for python-ufc, python-ffc, python-viper,
      python-ufl and python-instant in Depends field for binary package
      python-dolfin.
    - Bump version numbers for ufc and python-ufc in Build-Depends and
      in Depends field for binary package libdolfin1.0-dev.

 -- Johannes Ring <johannr@simula.no>  Thu, 08 Dec 2011 08:47:31 +0100

=== debian/control ===
Source: dolfin
Section: math
Priority: extra
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Johannes Ring <johannr@simula.no>
Build-Depends: cdbs (>= 0.4.90~),
 debhelper (>= 7),
 python-all-dev (>= 2.6.6-3~),
 cmake (>= 2.8.0),
 swig2.0,
 python-numpy,
 pkg-config,
 libxml2-dev,
 libboost-dev,
 libboost-program-options-dev,
 libboost-filesystem-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-iostreams-dev,
 libboost-mpi-dev,
 libboost-math-dev,
 libsuitesparse-dev,
 ufc (>= 2.0.5-3),
 python-ufc (>= 2.0.5-3),
 libptscotch-dev [!armel !armhf !kfreebsd-amd64 !kfreebsd-i386 !s390x],
 libpetsc3.2-dev [!armel !armhf !kfreebsd-amd64 !kfreebsd-i386 !s390x],
 libslepc3.2-dev [!armel !armhf !kfreebsd-amd64 !kfreebsd-i386 !s390x],
 libarmadillo-dev,
 libcgal-dev
Standards-Version: 3.9.3
X-Python-Version: >= 2.5
Homepage: http://fenicsproject.org
DM-Upload-Allowed: yes
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/fenics/dolfin/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/fenics/dolfin/trunk/

Package: libdolfin1.0-dev
Section: libdevel
Architecture: any
Depends: libdolfin1.0 (= ${binary:Version}),
 libxml2-dev,
 pkg-config,
 libboost-dev,
 libboost-program-options-dev,
 libboost-filesystem-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-iostreams-dev,
 libboost-mpi-dev,
 libboost-math-dev,
 libsuitesparse-dev,
 libptscotch-dev [!armel !armhf !kfreebsd-amd64 !kfreebsd-i386 !s390x],
 libpetsc3.2-dev [!armel !armhf !kfreebsd-amd64 !kfreebsd-i386 !s390x],
 libslepc3.2-dev [!armel !armhf !kfreebsd-amd64 !kfreebsd-i386 !s390x],
 libarmadillo-dev,
 cmake (>= 2.8.0),
 ufc (>= 2.0.5-3),
 python-ufc (>= 2.0.5-3),
 libcgal-dev,
 ${misc:Depends}
Conflicts: libdolfin0-dev
Replaces: libdolfin0-dev
Description: Shared links and header files for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files.

Package: dolfin-dev
Section: libdevel
Architecture: all
Depends: libdolfin1.0-dev, ${misc:Depends}
Description: Empty package depending on latest DOLFIN development package
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package will always depend on the most recent version of
 libdolfinX-dev (X=version), so if you install it then you will get
 upgrades automatically.

Package: libdolfin1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: dolfin-doc, libdolfin1.0-dbg, python-dolfin
Description: Shared libraries for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries.

Package: libdolfin1.0-dbg
Section: debug
Architecture: any
Depends: libdolfin1.0 (= ${binary:Version}), ${misc:Depends}
Description: Shared libraries with debugging symbols for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries with debugging symbols.

Package: python-dolfin
Section: python
Architecture: any
Depends: libdolfin1.0-dev (= ${binary:Version}),
 libdolfin1.0 (= ${binary:Version}),
 python-ufc (>= 2.0.5-3),
 python-ffc (>= 1.0.0),
 python-viper (>= 1.0.0),
 python-ufl (>= 1.0.0),
 python-instant (>= 1.0.0),
 python-numpy,
 swig2.0 (>= 2.0.7), swig2.0 (<< 2.0.8~),
 python-netcdf,
 ${python:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Suggests: dolfin-doc
Description: Python interface for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python interface for DOLFIN.

Package: dolfin-doc
Architecture: all
Section: doc
Depends: libdolfin1.0-dev (>= ${source:Version}),
 python-dolfin (>= ${source:Version}),
 ${misc:Depends}
Suggests: cmake (>= 2.8.0)
Description: Documentation and demo programs for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains documentation and demo programs for DOLFIN.

Package: dolfin-bin
Architecture: all
Depends: python-dolfin (>= ${source:Version}),
 ${python:Depends},
 ${misc:Depends}
Description: Executable scripts for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains executable scripts for DOLFIN.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_COMPRESS_EXCLUDE_ALL := .py .cpp .h .pdf
DEB_INSTALL_DOCS_ALL += AUTHORS README TODO

# Allow test programs that uses OpenMPI to run
export OMPI_MCA_plm_rsh_agent=/bin/false

# Disable MPI on lam architectures
ifeq ($(DEB_BUILD_ARCH), armel)
ENABLE_MPI=OFF
else ifeq ($(DEB_BUILD_ARCH), mips)
ENABLE_MPI=OFF
else ifeq ($(DEB_BUILD_ARCH), mipsel)
ENABLE_MPI=OFF
else ifeq ($(DEB_BUILD_ARCH), s390)
ENABLE_MPI=OFF
else ifeq ($(DEB_BUILD_ARCH), sparc)
ENABLE_MPI=OFF
else
ENABLE_MPI=ON
endif

DEFAULT_PY_VERSION = $(shell pyversions --default)

DEB_CMAKE_EXTRA_FLAGS= \
	-D BUILD_SHARED_LIBS:BOOL=ON \
	-D CMAKE_SKIP_RPATH:BOOL=ON \
	-D CMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
	-D DOLFIN_ENABLE_TRILINOS:BOOL=OFF \
	-D DOLFIN_ENABLE_CGAL:BOOL=ON \
	-D DOLFIN_ENABLE_MTL4:BOOL=OFF \
	-D DOLFIN_ENABLE_PARMETIS:BOOL=OFF \
	-D DOLFIN_ENABLE_UNIT_TESTS:BOOL=OFF \
	-D SWIG_EXECUTABLE:FILEPATH=/usr/bin/swig2.0 \
        -D DOLFIN_ENABLE_MPI:BOOL=$(ENABLE_MPI) \
	-D PETSC_DIR:PATH=/usr/lib/petscdir/3.2 \
	-D SLEPC_DIR:PATH=/usr/lib/slepcdir/3.2 \
	-D PYTHON_EXECUTABLE:FILEPATH=/usr/bin/$(DEFAULT_PY_VERSION) \
	-D PYTHON_LIBRARY:FILEPATH=/usr/lib/lib$(DEFAULT_PY_VERSION).so \
	-D PYTHON_INCLUDE_DIR:PATH=/usr/include/$(DEFAULT_PY_VERSION) \
	..

USCAN_DESTDIR := $(CURDIR)

PY_VERSIONS = $(shell pyversions --requested debian/control | tac -s' ')

install-stamp-%:
	cd $(DEB_BUILDDIR) && rm CMakeCache.txt && \
	  cmake $(DEB_CMAKE_NORMAL_ARGS) $(DEB_CMAKE_EXTRA_FLAGS) \
	    -D PYTHON_EXECUTABLE:FILEPATH=/usr/bin/$* \
	    -D PYTHON_LIBRARY:FILEPATH=/usr/lib/lib$*.so \
	    -D PYTHON_INCLUDE_DIR:PATH=/usr/include/$* \
	    ..
	make -C $(DEB_BUILDDIR) install DESTDIR=$(CURDIR)/debian/tmp
	touch $@

install/python-dolfin:: $(addprefix install-stamp-, $(PY_VERSIONS))

binary-install/python-dolfin::
	dh_python2 -p$(cdbs_curpkg)
	dh_numpy -p$(cdbs_curpkg)

binary-install/dolfin-bin::
	dh_python2 -p$(cdbs_curpkg)

clean::
	-rm -rf $(addprefix install-stamp-, $(PY_VERSIONS))

get-orig-source:
	uscan --force-download --verbose --destdir $(USCAN_DESTDIR) \
	 --download-version $(DEB_UPSTREAM_VERSION) \
	 --upstream-version $(DEB_UPSTREAM_VERSION)

=== debian/watch ===
version=3
https://launchpad.net/dolfin/+download https://launchpad.net/dolfin/.*/dolfin-(.*)\.tar\.gz
